;; StartJetty.scm
(define (addlibjars libpath)
  ;; here we extend the classpath to contain all jar files in the lib folder
  ;; e.g. (addlibjars "lib")
  (let ((jars 
         (map 
           (lambda(x) (java.io.File. {[libpath]/[x]}))
           (filter 
              (lambda(x) (.endsWith x ".jar")) 
              (array->list 
                  (.list (java.io.File. libpath)))))))
     (extendClassPath jars))
  )
(define (main args)
  ;; next we create the GUI for starting/stopping the server
  (let ()
    (define addquitaction 
      (lambda(x)
        (.addWindowListener x (jsint.Listener. (lambda(e)
          (if 
             (or
               (equal? (.getID e) java.awt.event.WindowEvent.WINDOW_CLOSING$)
               (equal? (.getID e) java.awt.event.WindowEvent.WINDOW_CLOSED$))
             (java.lang.System.exit 0)))))))

    (define w (window "Jscheme/Jetty server"
     (col
       (label {Server started at [(java.util.Date.)], local time})
       (label "closing this window will shutdown the server")
       (button "Shutdown server" (action (lambda(e)
          (java.lang.System.exit 0)))))))
    (addquitaction w)
    (.pack w)
    (.show w))
)

(load "elf/basic.scm")
(load "elf/classpath.scm")
(jlib.Swing.load)

(addlibjars "lib")
(display org.xml.sax.ContentHandler.class)(newline)
(tryCatch
   (org.mortbay.jetty.Server.main#
                (list->array java.lang.String.class 
                 '("etc/jetty.xml")))
   (lambda(e) 
        (display (list "ERROR" e))(newline)(newline) 
        ((lambda(x) (.show x)(.pack x)) (window "error" (label {Error in Server [e]})))))

